<template>
  <div class="choices">

    <div class="option-group">
    <!--<div style="margin-bottom: 10px;">
      <router-link :to="{ name: 'boilerplate', params: { bpConfig: getBoilerplateConfig } }"><button class="btn btn-primary">Generate Boilerplate</button></router-link>
    </div>
    -->
    <div style="margin-bottom: 20px;">
      <a :href="getZipUrl"><button class="btn btn-primary">Download boilerplate.zip</button></a>
    </div>
    </div>

    <div class="option-group">
    <p><b>Python Version</b></p>

    <div class="form-check">
      <label class="form-check-label">
        <input class="form-check-input" type="radio" name="pythonVersion" id="pythonVersion2" value="py2" @click="setPythonVersion2" :checked="isPythonVersion2">
        Python 2
      </label>
    </div>
    <div class="form-check">
      <label class="form-check-label">
        <input class="form-check-input" type="radio" name="pythonVersion" id="pythonVersion3" value="py3" @click="setPythonVersion3" :checked="isPythonVersion3">
        Python 3
      </label>
    </div>
    </div>

<!--
    <div class="form-group form-inline">
      <label class="" for="codeStyle">Code Style: &nbsp;
      <select class="form-control form-control-sm" id="codeStyle">
        <option>PEP8</option>
        <option>Google</option>
        <option>Facebook</option>
        <option>Chromium</option>
        <option>Custom</option>
      </select>
      </label>
    </div>

    <hr>-->

    <div class="option-group">
    <p><b>Options</b></p>

    <div class="form-check">
      <label class="form-check-label">
        <input class="form-check-input" type="checkbox" name="executable" value="1" @change="setExecutable" :checked="isExecutable">
        executable script
      </label>
    </div>

    <!-- disabled when not excecutable
    <div class="form-check" v-bind:class="{ disabled: !isExecutable }">
      <label class="form-check-label">
        <input class="form-check-input" type="checkbox" name="argparse" value="1" :disabled="!isExecutable" @change="setUseArgparse" :checked="isUsingArgparse">
        use <a href="https://docs.python.org/2/library/argparse.html" target="_blank">argparse</a>
      </label>
    </div>
    -->

    <div class="form-check">
      <label class="form-check-label">
        <input class="form-check-input" type="checkbox" name="argparse" value="1" @change="setUseArgparse" :checked="isUsingArgparse">
        argparse <a href="https://docs.python.org/2/library/argparse.html" target="_blank" class="link-light" title="Parser for command-line options, arguments and sub-commands"><icon name="info-circle" label="More information"></icon></a>
      </label>
    </div>

    <div class="form-check">
      <label class="form-check-label">
        <input class="form-check-input" type="checkbox" name="logging" value="1" @change="setUseLogging" :checked="isUsingLogging">
        logging <a href="https://logzero.readthedocs.io/en/latest" target="_blank" class="link-light" title="logzero is a module for easy and robust logging setup"><icon name="info-circle" label="More information"></icon></a>
      </label>
    </div>

    <div class="form-check">
      <label class="form-check-label">
        <input class="form-check-input" type="checkbox" name="logging" value="1" @change="setGitignore" :checked="isUsingGitignore">
        .gitignore
      </label>
    </div>
    </div>

    <div class="option-group">
      <p><b>Frameworks</b></p>

      <div class="form-check">
        <label class="form-check-label">
          <input class="form-check-input" type="checkbox" name="executable" value="1" @change="setUseFlask" :checked="isUsingFlask">
          Flask <router-link to="/flask" class="link-light" title="Flask is a micro webdevelopment framework for Python."><icon name="info-circle" label="More information"></icon></router-link>
        </label>
      </div>
    </div>


    <div style="display:block;">
        <p><b>Tests</b></p>

        <div class="form-check">
          <label class="form-check-label">
            <input class="form-check-input" type="checkbox" name="unittest" value="unittest" @change="setUseUnittest" :checked="isUsingUnittest">
            unittest <a href="https://docs.python.org/2/library/unittest.html" target="_blank" class="link-light" title="Python's unit testing framework"><icon name="info-circle" label="More information"></icon></a>
          </label>
        </div>

        <div class="form-check">
          <label class="form-check-label">
            <input class="form-check-input" type="checkbox" name="pytest" value="pytest" @change="setUsePyTest" :checked="isUsingPyTest">
            pytest <a href="https://docs.pytest.org/en/latest/" target="_blank" class="link-light" title="pytest helps you write better programs"><icon name="info-circle" label="More information"></icon></a>
          </label>
        </div>

        <div class="form-check">
          <label class="form-check-label">
            <input class="form-check-input" type="checkbox" name="argparse" value="1" @change="setUseTox" :checked="isUsingTox">
            &nbsp;tox <a href="https://tox.readthedocs.io/en/latest/" target="_blank" class="link-light" title="Test automation across Python versions"><icon name="info-circle" label="More information"></icon></a>
          </label>
        </div>
    </div>

    <div class="more">
      <p>
        <small style="color:#AAA;">More coming soon, and <router-link to="/about">you can help</router-link>. </small>
      </p>
      <p class="share-this-boilerplate">
        <small style="color:#AAA;">Share this boilerplate:<br>
          <div class="share-icons">
            <a :href="shareWithTwitterLink" @click.prevent="shareOnTwitter" title="Share on Twitter" class="twitter"><icon name="twitter" label="Share on Twitter"></icon></a>
            &nbsp;
            <a :href="shareWithEmailLink" @click.prevent="shareWithEmail" title="Share with Email" class="email"><icon name="envelope" label="Share with Email"></icon></a>
          </div>
        </small>
      </p>
    </div>

  </div>
</template>

<script>
import { mapGetters, mapActions, mapState } from 'vuex'

export default {
  name: 'choices',
  data () {
    return {
    }
  },
  computed: {
    ...mapGetters([
      'isPythonVersion2',
      'isPythonVersion3',
      'isUsingFlask',
      'isUsingGitignore',
      'isExecutable',
      'isUsingArgparse',
      'isUsingLogging',
      'isUsingUnittest',
      'isUsingPyTest',
      'isUsingTox',
      'getBoilerplateConfig',
      'getZipUrl',
      'shareWithTwitterLink',
      'shareWithEmailLink'
    ]),
    ...mapState([
      'route'
    ])
  },
  methods: {
    setUseFlask (e) {
      this.$store.dispatch('setFlask', e.target.checked)
    },
    setExecutable (e) {
      this.$store.dispatch('setExecutable', e.target.checked)
    },
    setUseArgparse (e) {
      this.$store.dispatch('setUseArgparse', e.target.checked)
    },
    setUseLogging (e) {
      this.$store.dispatch('setUseLogging', e.target.checked)
    },
    setGitignore (e) {
      this.$store.dispatch('setGitignore', e.target.checked)
    },
    setUseUnittest (e) {
      this.$store.dispatch('setUseUnittest', e.target.checked)
    },
    setUsePyTest (e) {
      this.$store.dispatch('setUsePyTest', e.target.checked)
    },
    setUseTox (e) {
      this.$store.dispatch('setUseTox', e.target.checked)
    },
    shareOnTwitter (e) {
      const url = this.$store.getters.shareWithTwitterLink
      window.open(url, 'PCwindow', 'width=550, height=350, menubar=no, toolbar=no, scrollbars=yes')
    },
    shareWithEmail (e) {
      const url = this.$store.getters.shareWithEmailLink
      window.open(url, 'PCwindow', 'width=550, height=450, menubar=no, toolbar=no, scrollbars=yes')
    },
    ...mapActions([
      'setPythonVersion2',
      'setPythonVersion3',
      'generateBoilerplate',
      'downloadZip'
    ])
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.choices {
  padding: 20px;
  padding-top: 14px;
  border-radius: 4px;
}

label {
  font-weight: normal;
}

.option-group {
  margin-bottom: 14px;
}

.up5 {
  /* Bootstrap puts this to radio inputs, and we use it to similarly align checkboxes below */
  margin-top: -5px;
}

.more {
  margin-top: 10px;
}

.link-light {
  color: #d6d6d6;
  transition: 0.4s;
}

.link-light:hover {
  color: #337ab7;
}

.link-light .fa-icon {
  width: auto;
  height: 13px;
  margin-bottom: -2px;
}

.share-icons {
  margin-top: 3px;
  margin-left: 2px;
}

.share-icons a {
}

.share-icons a.twitter {
  color: #00aced;
}

.share-icons a.email {
  color: #777;
}

.share-icons a {
  opacity: 0.6;
  transition: all 0.3s ease-in-out;
  -webkit-transition: all 0.3s ease-in-out;
}

.share-icons a:hover {
  opacity: 1.0;
}
</style>
